Version History:

  0.9.1pre10  FACTS - Free Advanced Creation/Translation System

    - The FORM Project has produced results, too!  The new
      FACTS Offline Rendering Module is in place.  It can
      render any .lvl into a PNG or set of PNGs.  Send in
      your comments; we know this isn't quite perfect yet.
       * Requested by divine.216

  0.9.1pre9  FACTS - Free Advanced Creation/Translation System

    - Now when you have AutoCheck enabled without AutoCorrect,
      FACE will highlight bad settings in red.  This makes 
      it much easier to see bad settings.  You can select
      "Run CFGCheck" from the "Tools" menu to rescan all the
      settings and redo the red highlighting.

    - Clicking (or moving to) a red highlighted setting will
      display an error message instead of a description in
      the status bar.  The error message explains what must
      be done to correct the error.

  0.9.1pre8  FACTS - Free Advanced Creation/Translation System

    - Edit menu not present on "General Settings" page in
      FACE.  You can't use it, so it shouldn't be there.

    - Changed FACE title bar to "FACTS Configuration Editor -
      C:\path\filename.ext" with a "*" at the end if the file
      has been changed.

    - Fixed a description running problem when the CFGCheck
      window is closed in FACE.

    - Added splash screen around CFGCheck in FACE, since it
      takes time to reload the settings.

  0.9.1pre7  FACTS - Free Advanced Creation/Translation System

    - The FACE project has been completed!  Now you'd like
      to know what it is, eh?  The FACE project was the
      secret development project to bring you the next
      phase of FACTS:  The FACTS Configuration Editor!

    - Moved development to VB6, since the FACE project has
      created new dependencies and code that compiles far
      better in VB6.  Since more dependencies were being
      added, RichText has been added for the configuration
      checking routines.

    - FACE project highlights:

      - Spreadsheet-like ship configuration page, with
        full selection and copy-paste functionality.

      - Simple general settings page with spreadsheet-
        like layout and editing functionality.

      - Integrated AutoCheck functionality, with optional
        AutoCorrect, both thanks to ideas from CFGCheck.

      - Auto-loading of descriptions from any .set/.sss.

      - Live descriptions in the status bar.

      - Full Windows Registry support for saving settings,
        description file, and test file locations.

  0.9.1pre6  FACTS - Free Advanced Creation/Translation System

    - Added Undo/Redo support to the "Edit Tiles" dialog.
      Now you can make a mistake or try things out.  (Had
      to change a few things, but it shouldn't hurt much.)
       * requested by Arilou Lalee'lay

  0.9.1pre5  FACTS - Free Advanced Creation/Translation System

    - Added Louis XV's CFGCheck program to the "Server"
      tab of the FACTS toolkit.  This is the first of the
      various things that the new code base made possible.
      The CFGCheck program has been largely recoded to fit
      into FACTS as an integrated system, and as a result,
      it will also check .set files.  (Inside FACTS, there
      is no difference.)
       * Thanks to Louis XV for his CFGCheck work.

    - The RichTextBox control in CFGCheck has been
      replaced with a standard TextBox control in this
      embedded version.  If there are no objections, the
      RichTextBox will be put back, which will require
      another .OCX download.  Still, it looks much better
      with color in the result log.

  0.9.1pre4  FACTS - Free Advanced Creation/Translation System

    - Wiped out the entire .cfg/.set/.sss code base.  Not
      one line was copied.  The new (and much, much, much
      more logical) code will allow some amazing things.

    - Added GetExtension() to the filename manipulation
      library.  No big deal, but it comes in handy.

  0.9.1pre3  FACTS - Free Advanced Creation/Translation System

    - Added right-click copy to the custom WallTile dialog.
      Now it works just like the Tileset dialog.
       * requested by Shiningforce

    - Added "Horizontal" and "Vertical" labels to the Door
      Mode Calculator.  Of course, the main reason is simply
      to differentiate the two sets of four.  You could just
      as easily make two sets of one or the other, or you
      could even switch them, but the labels follow the
      standard customary vertical/horizontal setup.

  0.9.1pre2  FACTS - Free Advanced Creation/Translation System

    - Added "Door Mode Calculator" to the "Server" tab.  A
      thread on the server help site seemed to indicate such
      a feature would be nice, and so here it is.  (It works
      both ways: door set <-> mode number.)

  0.9.1pre1  FACTS - Free Advanced Creation/Translation System

    - And so it begins... again.  This is the beginning of
      the next development series.  Several things have been
      queued up, and the first of these are implemented now.

    - Added a "WallTiles" button to the Tile tab.  This lets
      you create and edit WallTile definitions without going
      through the level editing items.
       * suggested by Shiningforce (although I had actually
         thought of this one before, he reminded me :)

    - Added confirmation to the WallTile dialog.  If you
      click OK or Cancel without having saved changes you
      made to a WTD, it will ask you to confirm.  Since "OK"
      does nothing for the new "WallTiles" button, it's a
      good idea to let the people know it won't save their
      work for them.

  0.9.0  FACTS - Free Advanced Creation/Translation System

    - Packaged and uploaded.  It's finally here.

  0.9.0-final  FACTS - Free Advanced Creation/Translation System

    - Fixed a race condition that would make the pasting
      highlight in the Edit Tiles dialog not go away.
       * bug caught by Shiningforce

    - This is officially the release version of FACTS-0.9.0.
      If any more bugs are caught and fixed before the final
      "FACTS-0.9.0.zip" hits the distribution server, they
      will be fixed and a new "-final-X" version released,
      but barring that, this will be the actual compile that
      will be released as "FACTS-0.9.0.exe".

  0.9.0pre16  FACTS - Free Advanced Creation/Translation System

    - Fixed bug in the bitmap code.  If the bitmap spec
      says a value can be zero (because you can compute it
      from other values), FACTS had better compute it from
      the other values if it is set to zero, eh?  The bug
      affected the comment code, actually, but because of
      an error in the bitmap spec implementation.
       * bug caught by Shiningforce

    - Changed a description in the "Info" tab to be more
      in line with what people actually think.  (What can
      we say?  Programmers just aren't normal.)

  0.9.0pre15  FACTS - Free Advanced Creation/Translation System

    - Fixed stale data bug or two in the custom walltile
      creation dialog.  Hopefully this will take care of
      the stale data bugs, which are the last known bugs
      outstanding in the FACTS-0.9.0preX series.
       * bug caught by Shiningforce

  0.9.0pre14  FACTS - Free Advanced Creation/Translation System

    - Fixed two bugs in the Custom WallTile dialog.

    - Reworked documentation.

  0.9.0pre13  FACTS - Free Advanced Creation/Translation System

    - Woo-hoo!  We are officially at feature freeze!
      Get those bug fixes in now... the only thing we
      have left to do is them and the documentation!

    - All file accesses should be reasonably safe now.
      Not all errors are acted on, but all errors should
      be caught.  Detailed error handling should be
      added for 1.0, but for now, the fact that FACTS
      shouldn't die on errors will do.

    - The Diff code has been improved by such a very
      absolutely amazing amount, it's not even funny.
      It should take on the order of less than a
      minute to do the main loop now, while before it
      had been taking a very, very long time.

    - The MakePicture() bug in the "Edit Tiles" form
      should be gone.  With the redesign and all, the
      offending code had likely already been eliminated.

  0.9.0pre12  FACTS - Free Advanced Creation/Translation System

    - Added palette copying function to "Edit Tiles"
      dialog.  You can now use the palette from any
      tileset in your custom tileset.  (It might not
      be too useful, but it's a feature that might
      just come in handy to someone someday, and it
      only took about seven lines of code.)  If 
      you're using tiles from different colored
      (paletted, that is) tilesets, it'll probably
      look a bit ugly, but now YOU can decide which
      way you want it to be ugly.

  0.9.0pre11  FACTS - Free Advanced Creation/Translation System

    - Another little showstopper: the "New Source"
      button in the "Edit Tiles" dialog should only
      change the custom tileset if the custom tileset
      is empty.  (Oh, yeah, _inside_ the "If" block.)
       * bug caught by Shiningforce

  0.9.0pre10  FACTS - Free Advanced Creation/Translation System

    - Nice little showstopper: the "Empty Tile" in the
      "Edit Tiles" dialog was not set up correctly.  The
      X and Y values were backward in the "paste" code,
      and the Y was offset by one as well.  It has been
      fixed now, and should function normally.
       * bug caught by Shiningforce

    - The new right-select code was not checking the
      tileset boundary values as it should, and so was
      creating error conditions in the tile copying
      routines.  Now it won't try to copy past the edges.
       * bug caught by Shiningforce, I think

  0.9.0pre9  FACTS - Free Advanced Creation/Translation System

    - Oh, this ought to be good.  The kludged-in back
      end code in the tileset and WallTile dialogs has
      now been completely eradicated.  And I wasn't
      even planning on doing that tonight. :)

    - Fixed right-click-copy in tileset manipulation
      dialog.  It will now remember what you've copied
      with the right button, and it will continue to
      paste that correctly until such a time as you
      select something different.
       * corrections requested by Shiningforce

    - Added rollovers to the tilesets and status bars
      to the bottom of the tileset-using dialogs (not
      the tileset selection dialog, since you don't
      mess with that tileset window).  Now FACTS has
      the single best feature of TileEdit -- it lets
      you know what tiles are what.
       * suggested by Shiningforce

    - Due to the complete redesign, there could be
      some outstanding issues with the tileset and
      WallTile dialogs.  If you find any, let us know
      and we'll get right on it.

  0.9.0pre8  FACTS - Free Advanced Creation/Translation System

    - Fixed a 1-byte offset in the comment embedding
      (and reading) code.  Now it won't wipe out the
      top right corner pixel of the tileset.
       * bug caught by Shiningforce

    - Changed MakePicture() to assist in finding the
      annoying bug that's hiding in it somewhere.

  0.9.0pre7  FACTS - Free Advanced Creation/Translation System

    - Added support for overlays and overlay diffs.

    - Overlay simply means to take all the tiles from a
      .lvl and place them over the corresponding spots
      on another .lvl.  Note: if you try to overlay a
      tile on a spot covered by a space station or other
      multi-tile object, but not on the top, left corner
      tile, your tile will not be placed.

    - Overlay diffs in FACTS are like normal diffs (they
      catalog all the changes between two levels), but
      they cannot _remove_ any tiles.  This is a design
      decision; in order to be able to remove tiles, you
      must necessarily break compatibility of the diff
      itself with SSME.  FACTS overlay diffs _can_ be
      used just like normal .lvl files (they _are_ just
      normal .lvl's).

    - Note: If there is a use for non-editable diffs,
      we can add support for non-SSME-compatible FACTS
      diffs that will be able to remove tiles, too.

    - Support for removing information from tilesets
      has been added (but not tested).  Hey, since we
      published the .bmp/.lvl specs, somebody would make
      a program to do it, and we had a space for another
      button, too.  Anyway, don't pirate, but if you
      need to pull the info out, you should be able to.

  0.9.0pre6  FACTS - Free Advanced Creation/Translation System

    - Added color signatures to WallTile Definition files.
      (They are currently in HTML's #RRGGBB format, but
      that isn't set in stone, yet.)  Old .wtd's will work
      fine with 0.9.0pre6+, but 0.9.0pre6+ .wtd's won't
      work with pre5- unless the color signatures are hand
      edited out of the .wtd.

    - Added embedded comment support.  FACTS can now embed
      text comments in tilesets (.bmp's or .lvl's with
      tilesets in them).  I have tried commented tileset
      levels in my local test server, and they work just
      as normal levels do.  Other graphics programs _may_
      obliterate the comments, but they won't choke on 
      them (as long as they follow the bitmap spec).

    - Note: Support for _removing_ comments was _not_
      added.  It is our philosophical position that there
      is not a need for that feature.  You can change the
      comments (which can get rid of all but the FACTS
      version signature), but you cannot remove all the
      comments.  If you want comment removal added to
      FACTS, let us know and we'll probably do it, but
      for now, we didn't think it was necessary (if you
      do find a program that requires comment-free files,
      we'll get that support in ASAP, so let us know).

  0.9.0pre5  FACTS - Free Advanced Creation/Translation System

    - Fixed the UI.  Now tab key cycles through the buttons
      in order, and all the buttons have "tooltip" info in
      the staus bar at the bottom.

    - Added "Example" WallTile set to WallTile selection
      dialog.  This should help new users know what goes
      where without having to go to the papers.
       * Suggestion by Shiningforce.
 
  0.9.0pre4  FACTS - Free Advanced Creation/Translation System

    - Long time no see.  I know this one was a long time
      coming.  This will officially begin the second season
      of active FACTS development.  (It's amazing what real
      life will throw at you, but coders never give up.)
      Updates should come faster again now that the team is
      playing again.

    - Serious UI redesign.  New "info buttons" added.
      It's tabbed, too.  The "info buttons" are not yet
      implemented, but the look is there.  (Implementation
      in progress, but requiring a major back-end redesign.)

    - Added right-click (or drag) in top tile manipulation
      window.  The right button in the top will "copy"
      tiles from itself (pasted via the left button, as
      always).  Now you can not only paste to the custom
      tileset, but you can copy within it as well.
       * Requested by Shiningforce

  0.9.0pre3  FACTS - Free Advanced Creation/Translation System

    - Added logic to find diagonals such as the one in
      the inside of a cut corner when there's only one
      diagonal tile on the inside and two on the outside.
      (This will likely be the last of the fixes from the
      intense diagonal studying I've been working on.)

  0.9.0pre2  FACTS - Free Advanced Creation/Translation System

    - Fixed the "boot" artifact problem (a "|\" instead
      of a "\\" where a diagonal intersects a line).  Of
      course, the fix breaks when you run a diagonal into
      a two-or-more tile thick wall, but fixing that isn't
      as important, since that is a much more difficult
      situation (and it doesn't matter at all if you only
      have diagonals intersecting one-tile thick walls).

  0.9.0pre1  FACTS - Free Advanced Creation/Translation System

    - Added tileset manipulation dialog.

    - Standardized temp file handling throughout FACTS.

    - Added more buttons to UI (even includes an
      "About"-style button now).

  0.8.0  FACTS - Free Advanced Creation/Translation System

    - The first official release of the new WallTile
      system and tileset previewing dialogs.  Woo-hoo!

    - Fixed WallTile definition loading functions.
      They should now handle the entire set of badly
      composed .wtd files.

    - Fixed preview support of tilesets with fewer than
      ten rows (can't release a new version that can't
      load _castle.lvl's tiles -- it wouldn't be right).

    - Fixed bug caused by Microsoft inconsistency in
      using or not using "\" at the end of a path.
       * bug caught by Snarklord

  0.8.0pre18  FACTS - Free Advanced Creation/Translation System

    - Release candidate: FACTS-0.8.0rc7.

    - Completed merging all conversion optimizations
      into the final tree.  With the changes merged
      in this version, the 3:25 pre15 time has been
      cut to 40 SECONDS total for the 100 maps. Total
      savings in non-WallTile sections: over 80%!

  0.8.0pre17  FACTS - Free Advanced Creation/Translation System

    - Release candidate: FACTS-0.8.0rc6.

    - Fixed the solo tile bug.  mods.lvl, one of the
      TrenchWars levels running on April 1st, had only
      one tile (a wormhole) and thus found a division
      by zero error (and a bunch of wanna-be-mods).
      (We mean it when we say FACTS should work for
      EVERY .lvl -- even the abnormal ones.)

    - Conversion logic improved again.  Cut time 55%.
      A 100 conversion benchmark on FACTS-0.8.0pre15
      ran in about 3:25, in pre16 it ran in 2:45, and
      now in pre17 it runs in 1:30.  That's a savings
      of almost two whole minutes for the non-WallTile
      bitmap to level conversion of the 100 maps (or,
      using my figures, 55% shaved off the non-WallTile
      conversion overhead).

  0.8.0pre16  FACTS - Free Advanced Creation/Translation System

    - Release candidate: FACTS-0.8.0rc5.

    - Conversion logic improved.  This change cut 20%
      off the non-WallTile processing time (not quite
      as substantial when using WallTiles, but it did
      cut 40 seconds off a 100-map batch conversion).

  0.8.0pre15  FACTS - Free Advanced Creation/Translation System

    - Release candidate: FACTS-0.8.0rc4.

    - The "Re-Link" button won't be enabled after an 
      operation if the "Use WallTiles" checkbox is not
      checked.

    - 0.8.0pre15-1 replaced the old docs with new ones.

  0.8.0pre14  FACTS - Free Advanced Creation/Translation System

    - Release candidate: FACTS-0.8.0rc3.

    - Found and fixed Cancel bug in "Split Tiles".

    - Added cancel functionality to the title bar
      of the "New BMP" map/tile selection dialog.

  0.8.0pre13  FACTS - Free Advanced Creation/Translation System

    - Release candidate: FACTS-0.8.0rc2.

    - Fixed Cancel bug in "Add Desc" routines.
       * bug caught by Snarklord

  0.8.0pre12  FACTS - Free Advanced Creation/Translation System

    - Reached "release candidate" status: FACTS-0.8.0rc1.

    - Fixed "Clear Current" to clear the entire current
      WallTile (it had been missing the first tile).

    - Added check for the continued existence of the
      last loaded .wtd before attempting to reload it
      when returning to the WallTile dialog.

    - Cleaned up display of WallTile dialog to not
      show a partially drawn form.  It will now make
      sure the form is fully drawn before populating
      it with WallTiles, and no leftovers from the
      last loaded .wtd will flash by the top.

  0.8.0pre11  FACTS - Free Advanced Creation/Translation System

    - Added support for "Tile Zero".  The WallTile
      definiton dialog now has a special "hole" tile
      above the top, left corner of the tileset.  The
      "hole" tile will show up in the WallTile as a
      teeny picture of the tileset palette (so it
      can't be confused).  "Tile Zero" is not rendered
      in the conversion.

    - Fixed the extra tiles for large asteroids, space
      stations, and wormholes to be the right pixel
      values in deconverted bitmaps.

  0.8.0pre10  FACTS - Free Advanced Creation/Translation System

    - NOTE: WallTile definition files (.wtd's) from
      version 0.8.0pre9 will not work with this version.
      The tile numbers have been shifted up one in order
      to be consistent with the TileEdit and .lvl file
      numbering schemes.  (And of course, the .wtd's
      from before 0.8.0pre9 won't work at all, since
      they used the old "Expert" dialog.)

    - Removed the last vestiges of the original static
      WallTile and diagonal definitions.  There is now
      only one "Use WallTiles" checkbox on the main form.
      (It made no sense to take one arbitrary pattern and
      declare it to be above all the others, especially
      since it is definitely nowhere near as useful as
      any given user-defined layout.)

    - Linked the "Re-Link" buttons status to the "Use
      WallTiles" checkbox.  (If you have no WallTiles,
      you have nothing to re-link.)

    - Without a given WallTile being defined, FACTS will
      simply ignore that palette entry ("color") in the
      map .bmp -- this means that if you uncheck the "Use
      WallTiles" checkbox, your WalLTiles will not be
      rendered in the .lvl (could be fun if you want to
      see how much of your map is WallTiles).  Before this
      version, FACTS would always convert the original
      eight WallTiles; now it won't.

    - Changed default status of "Use WallTiles" checkbox
      to "checked".  It just seemed like the right thing
      to do, since FACTS basically _is_ WallTiles.

  0.8.0pre9  FACTS - Free Advanced Creation/Translation System

    - Oh, my!  Added the code from our "Hero UI" project
      to the FACTS tree.  The previous Expert dialog box
      is no more; its functionality has been absorbed into
      the new, amazing dialog codenamed "Hero UI".

    - The "Hero UI" dialog necessitated changes throughout
      the FACTS code.  Many changes were put in place prior
      to pre9, but quite a bit of code was changed in the
      merge as well.

    - FACTS now supports a completely arbitrary number of
      WallTiles (up to 32), and they can be composed of any
      tiles in the tileset.  Diagonals are optional on a
      per-WallTile basis.

    - The map .bmp pallette was changed to accomodate the
      addition of 24 new WallTiles.

    - Diagonal status is now stored in an array of Boolean
      values.  The previous bitmapped format broke down when
      we found out VB overflows when trying to compute 2^31
      AND 2^31.

    - The WallTile definition files (.wtd's) are plain text
      and can be edited in Notepad or whatever.  If you're
      going to do a 32 WallTile redundant set, the text rules.

    - 0.8.0pre9-1 added a "- 1" to make FACTS use the right
      number of WallTiles, also fixed non-expert diagonals.

  0.8.0pre8  FACTS - Free Advanced Creation/Translation System

    - Re-fixed a couple bugs that apparently fell through
      when a patch was applied to an old source file instead
      of the correct, current one.  (Must... have... sleep...)
       * bugs re-caught by Shiningforce

  0.8.0pre7  FACTS - Free Advanced Creation/Translation System

    - Fixed the cancel (i.e., [x]) button in the Expert
      dialog box to work more logically.  (Is it done yet?)
       * continued bug reports by Shiningforce :)

  0.8.0pre6  FACTS - Free Advanced Creation/Translation System

    - Changed version from 0.7.1preX to 0.8.0preX.  The 
      scale of the changes and significance of the new
      features added in this series warrant a change in
      version numbers.

    - Completed the back end code for processing an
      arbitrary number of arbitrarily mapped WallTiles.
      The front end code (the Custom dialog) is now in
      development under the code name "Hero UI".

  0.7.1pre5  FACTS - Free Advanced Creation/Translation System

    - Continued modification to back end code, this time
      to add partial support for more (or less) than eight
      WallTiles (for the future "Custom" dialog).

    - Added [x] button to the title bar of the "Expert"
      dialog.  Cancelling the dialog will revert to whatever
      selection existed before it popped up.
       * idea by Shiningforce

    - Added refresh of the preview dialog on activation to
      get rid of a stale files (i.e., if you delete a file
      with FACTS running, it should not still show up when
      you return to the preview dialog).      
       * bug caught by Shiningforce

  0.7.1pre4  FACTS - Free Advanced Creation/Translation System

    - Radically redesigned the WallTile <-> real tile
      associations.  Now uses an array to map the values
      instead of having them hard-coded.  With this design,
      FACTS will be able to support the upcoming Custom
      tileset configuration feature.

    - 0.7.1pre4-1 fixed one digit in conversions and made
      the "Expert" dialog only show up when appropriate.

  0.7.1pre3  FACTS - Free Advanced Creation/Translation System

    - Added "Re-Link" function to FACTS.  Basically, what
      this does is deconverts and re-converts a .lvl (it's
      a .lvl->.lvl conversion).  By doing this, you can
      add or remove diagonals, or "Re-Link" all the WallTiles
      in the map (useful if you messed with it in SSME or
      whatever, since you can use any WallTile of a group to
      draw, and then just "Re-Link" it into a finished .lvl.
       * requested by Shiningforce

    - An error in the WallTile set deconversion was detected
      thanks to the new "Re-Link" function, and was promptly
      corrected (54 to _57_ is four tiles, not to 58, duh).

    - Merged the buttons for new map .bmp's and new tileset
      .bmp's into one button (to make room for "Re-Link" on
      one of the buttons).

  0.7.1pre2  FACTS - Free Advanced Creation/Translation System

    - Finally added the tileset previewing function to
      FACTS.  Now you can see a bit of what you're doing.
       * requested by Shiningforce

    - Moved "Expert" dialog.  Instead of popping up on
      click, it now pops up after selecting the tileset in
      the new preview-enabled tileset selection dialog.
      This is more logical, and will be necessary when the
      "Custom" dialog is implemented.

    - Added a "Use this for all deconversions." checkbox to
      the "Expert" dialog, visible only when deconverting
      multiple .lvl's (the only case where multiple tilesets
      are involved in one process).

    - Fixed the "Info" window to only .Show the form once
      per processing task instead of once per file.

  0.7.1pre1  FACTS - Free Advanced Creation/Translation System

    - Changed FACTS source to use comdlg32.dll instead of
      comdlg32.ocx.  Everyone with Windows has comdlg32.dll,
      but not everyone had comdlg32.ocx.

       *** >0.7.1pre1-1 uses the .ocx due to errors ***

    - Added load/save to "Expert" WallTile/diagonal selection
      dialog box (also added disabled "Custom" button for
      future custom-mapped tileset feature).
       * suggested by Shiningforce

    - Made "Expert" dialog box modal (works better this way).

  0.7.0  FACTS - Free Advanced Creation/Translation System

    - Fixed bug in expert diagonal selection routine.

    - Rebranded final version as "FACTS - SubSpace.net"
      instead of "FACTS - ss.ClayJar.com" as part of a
      cross-promotional deal.  Prerelease versions will
      remain at ss.ClayJar.com, and releases will be
      distrubuted from SubSpace.net (in association with
      ss.ClayJar.com).

    - 0.7.0-1 fixed one digit in conversions and a bit of text.
       * bug caught by Shiningforce

    - 0.7.0-2 fixed another bug in expert diagonal selection.
      The conversion routines were not functioning properly,
      due to a stupid mistake (I have to use _both_ variables).
       * bug caught by Shiningforce

  0.7.0pre5  FACTS - Free Advanced Creation/Translation System

    - Polished off parts of the UI.  (Now always asks for
      tilesets _after_ .bmp, .lvl, or whatever... nothing like
      consistency, eh?)

    - Added very basic size checks for .bmp's.  If it's bigger
      than 50K or so, it can't be a tileset.  If it's smaller
      than about 1026K or so, it can't be a map.

  0.7.0pre4  FACTS - Free Advanced Creation/Translation System

    - Fixed "first tile" bug.  If at least one WallTile was not
      being used, and the top left tile (tile offset 0) was not
      a WallTile later than the unused WallTile, the top left
      tile would be incorrectly changed to the last unused
      WallTile.  Now if there are no WallTiles of a particular
      kind, the routine won't even go through the loop once
      (those who have done such things with "For" loops have
      permission to snicker, but only for a few moments).
       * bug caught by Shiningforce

  0.7.0pre3  FACTS - Free Advanced Creation/Translation System

    - Added "Border tile" (tile 20) to the tileset (the first
      WallTile's diagonal was using it, which was wrong; also
      added it to the level map .bmp palette; shifted WallTile
      diagonals to not use tile 20).
       * bug caught by Shiningforce

    - Fixed example tileset diagonals (missing six dots).
       * bug caught by Shiningforce

    - Fixed "Apply Tiles" button (now it doesn't become two
      lines when selected or clicked).
       * bug caught by Shiningforce

  0.7.0pre2  FACTS - Free Advanced Creation/Translation System

    - Added diagonal support to WallTile technology.

    - Custom tileset now included in package (it doesn't look
      great, but it gets the job done and is a good example).

    - 0.7.0pre2-1 added an icon to the program (at last).

  0.7.0pre1  FACTS - Free Advanced Creation/Translation System

    - Added WallTile technology for rapid level creation.

  0.6.1  FACTS - Free Advanced Creation/Translation System

    - Found and fixed a one-byte offset which showed up
      thanks to the new, faster (de)conversion routines.

    - Found a bug which prevents map bitmaps with quite
      excessively large tile counts from converting properly.
      (If you found this bug, you ought to cut back a bit.)

  0.6.0  FACTS - Free Advanced Creation/Translation System

    - Now logically handles .bmp pixel order when converting
      to .lvl -- as such, it is no longer necessary to sort
      the tiles on load, which obviously is somewhat helpful
      in the quest for performance.

    - Implemented shell sort (as opposed to bubble sort) in
      several routines (mostly in the .set<->.cfg areas).
      (Hey, I had to look it up!  Sosumi! :)

    - Cleaned up the "apply descriptions" logic; now it's a
      _whole_ lot faster.

  0.6.0pre3  FACTS - Free Advanced Creation/Translation System

    - Seriously improved conversion speed in several places.
      It had been bound by inefficient I/O calls; now mostly
      bound by inefficient sorting algorithms. :)

    - Standardized method of creating new filenames if the
      target filename already exists.

  0.6.0pre2  FACTS - Free Advanced Creation/Translation System

    - Fixed bug in the blank tileset creation routines.
      (The .bmp header wasn't being written correctly
       since version 0.5.0!  If you find bugs like this,
       please let me know of them ASAP!)

    - Tremendously cleaned up user interface code, which
      had become unwieldy.  Now it's all nice and pretty
      again, and a bunch of midnight code has been replaced
      with much more intuitive routines.

  0.6.0pre1  FACTS - Free Advanced Creation/Translation System

    - Added initial support for conversions between
      .set and .cfg files (thanks to Mine GO BOOM for
      the suggestion).

    - Converts .cfg to .set (no descriptions or with
      descriptions pulled from .sss or .set file).

    - Converts .set to .cfg (descriptions can be included
      as comments in the generated .cfg).

    - Adds descriptions from .sss or .set file to an
      existing .set file.

    - All .set/.cfg functions are batch-enabled.


-------------------------------------------------------------

  0.5.0  FACTS - Free Advanced Creation/Translation System

    - This is it!  Every feature that was supposed to
      make it into FACTS has made it.  Expect slight
      changes and improvements, not to mention bugfixes,
      but as of now, FACTS is really worth a download.

    - Fixed lots of insidious bugs... and tested even.

    - Now compares two calculated filesizes to detect
      extraneous bytes (_melted.lvl AND _castle.lvl
      both had this problem, and _castle.lvl has a nine
      row tileset, too!)

    - All operations checked and rechecked (and I should
      even have the right file in the distribution, too)

    - Added batch processing of Convert, Deconvert, Apply,
      and Split routines.

    - Streamlined UI with respect to clicks.  There are
      no more windows that pop up and require a click to
      continue during an operation.

    - Info window added.  This is where batch progress is
      displayed, as well as non-error messages from within
      the conversion routines (i.e., if you include a level
      without a tileset in a Split batch, you will get a
      warning here, and no operation on the level will be
      performed).

    - Many "percent" progress indicators added.  There were
      a few places where certain steps could take longer
      than normal (splitting a _large_ level), so "percent"
      indicators were added throughout.  This also aids the
      responsiveness of the windows to dragging, resizing,
      and all around responding.

    - Input files for various operations are now required
      to exist.  (It seems like a good idea, eh?)

    - Overwrite prompt added to "Map BMP" and "Tile BMP",
      since these create a new file using user input.

    - Added checks for file size and correct bitmap headers.
      (Width is important, but you could probably make a
       map with extra information above the 1024-pixel high
       line and still convert it... for now.  More rigorous
       checks may be added later, but since there are 
       known cases of bad files working in SubSpace, I'd
       be reluctant to require them.)

    - Various details have continued to be worked on, but
      they are mostly tweaks and code cleanup, not UI stuff.


  0.4.4-1  FACTS - Free Advanced Creation/Translation System

    - Conversion Unity Release:
        EVERY SubSpace .lvl I have can now be converted
        successfully!  Screenshots of each tileset and
        map are available in the download directory of
        FACTS at http://ss.ClayJar.com/


  0.4.4  FACTS - Free Advanced Creation/Translation System

    - Now asks you is you want to wipe the tileset pallette
      (Some tilesets use non-standard pallettes)

    - Added support for tilesets with fewer than 10 rows
      (i.e., in _castle.lvl) and tilesets that are just a
      little bit wrong (i.e. removes the two extraneous
      bytes from _melted.lvl)  (Tilesets of less than 10
      rows cannot yet have their tilesets wiped; this will
      be addressed in 0.4.4-1.)


  0.4.3  FACTS - Free Advanced Creation/Translation System

    - Deconversion routines now add "dummy pixels" to mark
      the layout of extended tiles (wormholes now show up
      as 5x5 patches in the .bmp, but only the pixel at the
      upper left which is a slightly different color is
      translated)

        *Note: normal 1x1 tiles end at index 190 (the 191'st
               color, since the first is index 0), and with
               the exception of 216 (small asteroid), 217 
               (large asteroid), 219 (starport), and 220
               (wormhole), all colors above index 190 in the
               pallette are ignored in the translation to a
               SubSpace .lvl

    - Blank level .bmp pallette changed slightly to make the
      "dummy pixel" patches possible, as well as to make the
      asteroid pixels brown (hey, it ought to help a little)

    - Fixed a one tile offset in the deconversion routines
      (nothing like a little detailed testing to weed out
       little bugs here and there)


  0.4.2-2  FACTS - Free Advanced Creation/Translation System

    - Slightly changed progress computation for readability
      and incremental speed increase, and added slight tweaks
      in the display routines to prevent ugliness.

    - Now changes the pallette of tilesets split from .lvl
      files to the standard SubSpace pallette.  (The tileset
      from the original Trench Wars map, trenchrd.lvl, had
      a black-and-white pallette, which made it somewhat 
      difficult to work with; now that can't happen.)


  0.4.2-1  FACTS - Free Advanced Creation/Translation System

    - Fixed little problem by reading tile placement data
      by starting AFTER the embedded tileset, if such a
      tileset exists.  Call me dumb, but I'm only here to
      help. :)


  0.4.2  FACTS - Free Advanced Creation/Translation System

    - Rewrote deconversion routines (it now generates a 
        standard blank level and then places the individual
        tile pixels afterward)

    - Changes yielded a large speed increase and more 
        stable and readable deconversion routines


  0.4.1  FACTS - Free Advanced Creation/Translation System

    - Fixed show stopper bug in deconversion routine


  0.4.0  FACTS - Free Advanced Creation/Translation System

    - Added the ability to convert .lvl to .bmp
       (embedded tileset, if present, is saved
        as an additional .bmp)

    - Internal code has been somewhat restructured

    - Official announcement of FACTS distribution will
      likely occur with this release.  We are still
      calling it "alpha" or "beta", since we anticipate
      doing a great number of improvements before we
      call it a version 1.0, but we believe it is both
      usable and _useful_ as of this version.


-------------------------------------------------------------

  0.3.0  FACTS - Free Advanced Creation/Translation System

    - Renamed from BMP2LVL to FACTS; the addition of tileset
       support expanded the program from being a simple
       translator to being a complete creation system

    - Added tileset support including:

       - Generating a blank tileset .bmp
          (uses the standard SubSpace pallette)

       - Adding a tileset to a level (.lvl) file
          (source can be .bmp or .lvl with tileset)

       - Splitting a .lvl with tileset into a .bmp
          tileset and a plain .lvl


-------------------------------------------------------------

  0.2.0  BMP2LVL

    - Added ability to generate a blank bitmap to edit

    - Added basic pallette for generated bitmaps

    - Added support of special tiles (remove overlaps)


-------------------------------------------------------------

  0.1.0  BMP2LVL

    - "Proof of concept" version

    - Converted bitmaps to levels


-------------------------------------------------------------

  0.0.0  Concept

    - Researched .bmp and .lvl file formats
    - Performed manual adjustments

-------------------------------------------------------------
